import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface Sesv2ConfigurationSetConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#configuration_set_name Sesv2ConfigurationSet#configuration_set_name}
    */
    readonly configurationSetName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#id Sesv2ConfigurationSet#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#tags Sesv2ConfigurationSet#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#tags_all Sesv2ConfigurationSet#tags_all}
    */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
    * delivery_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#delivery_options Sesv2ConfigurationSet#delivery_options}
    */
    readonly deliveryOptions?: Sesv2ConfigurationSetDeliveryOptions;
    /**
    * reputation_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#reputation_options Sesv2ConfigurationSet#reputation_options}
    */
    readonly reputationOptions?: Sesv2ConfigurationSetReputationOptions;
    /**
    * sending_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#sending_options Sesv2ConfigurationSet#sending_options}
    */
    readonly sendingOptions?: Sesv2ConfigurationSetSendingOptions;
    /**
    * suppression_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#suppression_options Sesv2ConfigurationSet#suppression_options}
    */
    readonly suppressionOptions?: Sesv2ConfigurationSetSuppressionOptions;
    /**
    * tracking_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#tracking_options Sesv2ConfigurationSet#tracking_options}
    */
    readonly trackingOptions?: Sesv2ConfigurationSetTrackingOptions;
}
export interface Sesv2ConfigurationSetDeliveryOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#sending_pool_name Sesv2ConfigurationSet#sending_pool_name}
    */
    readonly sendingPoolName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#tls_policy Sesv2ConfigurationSet#tls_policy}
    */
    readonly tlsPolicy?: string;
}
export declare function sesv2ConfigurationSetDeliveryOptionsToTerraform(struct?: Sesv2ConfigurationSetDeliveryOptionsOutputReference | Sesv2ConfigurationSetDeliveryOptions): any;
export declare class Sesv2ConfigurationSetDeliveryOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Sesv2ConfigurationSetDeliveryOptions | undefined;
    set internalValue(value: Sesv2ConfigurationSetDeliveryOptions | undefined);
    private _sendingPoolName?;
    get sendingPoolName(): string;
    set sendingPoolName(value: string);
    resetSendingPoolName(): void;
    get sendingPoolNameInput(): string | undefined;
    private _tlsPolicy?;
    get tlsPolicy(): string;
    set tlsPolicy(value: string);
    resetTlsPolicy(): void;
    get tlsPolicyInput(): string | undefined;
}
export interface Sesv2ConfigurationSetReputationOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#reputation_metrics_enabled Sesv2ConfigurationSet#reputation_metrics_enabled}
    */
    readonly reputationMetricsEnabled?: boolean | cdktf.IResolvable;
}
export declare function sesv2ConfigurationSetReputationOptionsToTerraform(struct?: Sesv2ConfigurationSetReputationOptionsOutputReference | Sesv2ConfigurationSetReputationOptions): any;
export declare class Sesv2ConfigurationSetReputationOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Sesv2ConfigurationSetReputationOptions | undefined;
    set internalValue(value: Sesv2ConfigurationSetReputationOptions | undefined);
    get lastFreshStart(): string;
    private _reputationMetricsEnabled?;
    get reputationMetricsEnabled(): boolean | cdktf.IResolvable;
    set reputationMetricsEnabled(value: boolean | cdktf.IResolvable);
    resetReputationMetricsEnabled(): void;
    get reputationMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface Sesv2ConfigurationSetSendingOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#sending_enabled Sesv2ConfigurationSet#sending_enabled}
    */
    readonly sendingEnabled?: boolean | cdktf.IResolvable;
}
export declare function sesv2ConfigurationSetSendingOptionsToTerraform(struct?: Sesv2ConfigurationSetSendingOptionsOutputReference | Sesv2ConfigurationSetSendingOptions): any;
export declare class Sesv2ConfigurationSetSendingOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Sesv2ConfigurationSetSendingOptions | undefined;
    set internalValue(value: Sesv2ConfigurationSetSendingOptions | undefined);
    private _sendingEnabled?;
    get sendingEnabled(): boolean | cdktf.IResolvable;
    set sendingEnabled(value: boolean | cdktf.IResolvable);
    resetSendingEnabled(): void;
    get sendingEnabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface Sesv2ConfigurationSetSuppressionOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#suppressed_reasons Sesv2ConfigurationSet#suppressed_reasons}
    */
    readonly suppressedReasons?: string[];
}
export declare function sesv2ConfigurationSetSuppressionOptionsToTerraform(struct?: Sesv2ConfigurationSetSuppressionOptionsOutputReference | Sesv2ConfigurationSetSuppressionOptions): any;
export declare class Sesv2ConfigurationSetSuppressionOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Sesv2ConfigurationSetSuppressionOptions | undefined;
    set internalValue(value: Sesv2ConfigurationSetSuppressionOptions | undefined);
    private _suppressedReasons?;
    get suppressedReasons(): string[];
    set suppressedReasons(value: string[]);
    resetSuppressedReasons(): void;
    get suppressedReasonsInput(): string[] | undefined;
}
export interface Sesv2ConfigurationSetTrackingOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set#custom_redirect_domain Sesv2ConfigurationSet#custom_redirect_domain}
    */
    readonly customRedirectDomain: string;
}
export declare function sesv2ConfigurationSetTrackingOptionsToTerraform(struct?: Sesv2ConfigurationSetTrackingOptionsOutputReference | Sesv2ConfigurationSetTrackingOptions): any;
export declare class Sesv2ConfigurationSetTrackingOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Sesv2ConfigurationSetTrackingOptions | undefined;
    set internalValue(value: Sesv2ConfigurationSetTrackingOptions | undefined);
    private _customRedirectDomain?;
    get customRedirectDomain(): string;
    set customRedirectDomain(value: string);
    get customRedirectDomainInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set aws_sesv2_configuration_set}
*/
export declare class Sesv2ConfigurationSet extends cdktf.TerraformResource {
    static readonly tfResourceType = "aws_sesv2_configuration_set";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sesv2_configuration_set aws_sesv2_configuration_set} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options Sesv2ConfigurationSetConfig
    */
    constructor(scope: Construct, id: string, config: Sesv2ConfigurationSetConfig);
    get arn(): string;
    private _configurationSetName?;
    get configurationSetName(): string;
    set configurationSetName(value: string);
    get configurationSetNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    get tagsAll(): {
        [key: string]: string;
    };
    set tagsAll(value: {
        [key: string]: string;
    });
    resetTagsAll(): void;
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _deliveryOptions;
    get deliveryOptions(): Sesv2ConfigurationSetDeliveryOptionsOutputReference;
    putDeliveryOptions(value: Sesv2ConfigurationSetDeliveryOptions): void;
    resetDeliveryOptions(): void;
    get deliveryOptionsInput(): Sesv2ConfigurationSetDeliveryOptions | undefined;
    private _reputationOptions;
    get reputationOptions(): Sesv2ConfigurationSetReputationOptionsOutputReference;
    putReputationOptions(value: Sesv2ConfigurationSetReputationOptions): void;
    resetReputationOptions(): void;
    get reputationOptionsInput(): Sesv2ConfigurationSetReputationOptions | undefined;
    private _sendingOptions;
    get sendingOptions(): Sesv2ConfigurationSetSendingOptionsOutputReference;
    putSendingOptions(value: Sesv2ConfigurationSetSendingOptions): void;
    resetSendingOptions(): void;
    get sendingOptionsInput(): Sesv2ConfigurationSetSendingOptions | undefined;
    private _suppressionOptions;
    get suppressionOptions(): Sesv2ConfigurationSetSuppressionOptionsOutputReference;
    putSuppressionOptions(value: Sesv2ConfigurationSetSuppressionOptions): void;
    resetSuppressionOptions(): void;
    get suppressionOptionsInput(): Sesv2ConfigurationSetSuppressionOptions | undefined;
    private _trackingOptions;
    get trackingOptions(): Sesv2ConfigurationSetTrackingOptionsOutputReference;
    putTrackingOptions(value: Sesv2ConfigurationSetTrackingOptions): void;
    resetTrackingOptions(): void;
    get trackingOptionsInput(): Sesv2ConfigurationSetTrackingOptions | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
